import { app } from '@/app.ts';
import { useContextKey } from '@kevisual/use-config/context';
import { WxServices } from './services.ts';
app
  .route({
    path: 'wx',
    key: 'checkLogin',
  })
  .define(async (ctx) => {
    const state = ctx.query.state;
    const redis = useContextKey('redis');
    const token = await redis.get(`wx:mp:login:${state}`);
    if (!token) {
      ctx.throw(400, 'Invalid state');
      return;
    }
    ctx.body = {
      token,
    };
  })
  .addTo(app);

app
  .route({
    path: 'wx',
    key: 'mplogin',
  })
  .define(async (ctx) => {
    const state = ctx.query.state;
    const code = ctx.query.code;
    try {
      const wx = new WxServices();
      const token = await wx.login(code);
      const redis = useContextKey('redis');
      await redis.set(`wx:mp:login:${state}`, token, 'EX', 10000); // 30秒过期
      ctx.body = {
        token,
      };
    } catch (error) {
      console.error(error);
      ctx.throw(500, 'Invalid code');
    }
  })
  .addTo(app);
